#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/un.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>

#define MAXLINE 256

#define SOCKET "./server.socket"

int main(int argc, char **argv)
{
  int sockfd, newsockfd, num_read;
  struct sockaddr_un servaddr;
  char buffer[MAXLINE];
 
  /* creates socket stream domain unix */
  if ((sockfd = socket(AF_UNIX, SOCK_STREAM, 0)) < 0){
    perror("server: can't open stream socket");
    exit(-1);
  }

  /* structure address cleaning */
  bzero(&servaddr, sizeof(servaddr));
  servaddr.sun_family = AF_UNIX;
  strcpy(servaddr.sun_path, SOCKET);

  /* if exists, deletes socket file name */
  unlink(servaddr.sun_path);

  /* binds socket to address */
  if (bind(sockfd, (struct sockaddr *) &servaddr, sizeof(servaddr)) < 0){
    perror("server, can't bind to address");
    exit(-1);
  }

  /* allows for 5 pending clients until connection is accepted */
  listen(sockfd, 5);
  
  while(1) {

    /* accept a connection on a socket */
    newsockfd = accept(sockfd, (struct sockaddr *) NULL, NULL);
    
    /* read string from client */
    num_read = read(newsockfd, buffer, MAXLINE);
    if (num_read > 0) {
      
      /* echo string to client */
      write(newsockfd, buffer, num_read);
    
    }

    close(newsockfd);
  }
}
